/*+======++         
 *  linux/init/main.c
 *
 *  Copyright (C) 1991, 1992  Linus Torvalds
 *
 *  GK 2/5/95  -  Changed to support mounting root fs via NFS
 *  Added initrd & change_root: Werner Almesberger & Hans Lermen, Feb '96
 *  Moan early if gcc is old, avoiding bogus kernels - Paul Gortmaker, May '96
 *  Simplified starting of init:  Michael A. Griffith <grif@acm.org> 
 */



//struct my_list_head {
//	struct my_list_head *next, *prev;
//};
/*
typedef struct z_stream_s {
int i;
} z_stream;

typedef z_stream *z_streamp;

void inflate_fast(z_streamp strm, unsigned start)
{
}
*/
#include "tlx2.h"

unsigned long my_data[1024];
#define THREAD_SIZE		8192
/*
#define INIT_THREAD_INFO(tsk)		

				\
{									\
	.task		= &tsk,						\
	.exec_domain	= &default_exec_domain,				\
	.flags		= 0,						\
	.preempt_count	= INIT_PREEMPT_COUNT,				\
	.addr_limit	= KERNEL_DS,					\
	.cpu_domain	= domain_val(DOMAIN_USER, DOMAIN_MANAGER) |	\
			  domain_val(DOMAIN_KERNEL, DOMAIN_MANAGER) |	\
			  domain_val(DOMAIN_IO, DOMAIN_CLIENT),		\
	.restart_block	= {						\
		.fn	= do_no_restart_syscall,			\
	},								\
}
*/

union my_thread_union {
//	struct thread_info thread_info;
	unsigned long stack[THREAD_SIZE/sizeof(long)];
};

union my_thread_union my_init_thread_union;//  =
//	{ INIT_THREAD_INFO(my_data) };

unsigned int my___atags_pointer;
unsigned int my___machine_arch_type;
unsigned int my_processor_id;

        extern my_memset(unsigned long a, unsigned long b, unsigned long c);
        extern my_memcpy(unsigned long a, unsigned long b, unsigned long c);
	extern void my_cpu_arm926_set_pte_ext(unsigned long a, unsigned long b ,unsigned long c);              
	extern void  my_cpu_arm926_dcache_clean_area(unsigned long a, unsigned long b);	
	extern int my__find_next_zero_bit_le(const void * p, int size, int offset);

#define BITS_PER_LONG 32
#define BIT_MASK(nr)		(1UL << ((nr) % BITS_PER_LONG))
#define BIT_WORD(nr)		((nr) / BITS_PER_LONG)


#define max(x, y) ({				\
	typeof(x) _max1 = (x);			\                       
	typeof(y) _max2 = (y);			\
	(void) (&_max1 == &_max2);		\
	_max1 > _max2 ? _max1 : _max2; })

int my_test_bit(int nr, const volatile unsigned long *addr)
{
	return 1UL & (addr[BIT_WORD(nr)] >> (nr & (BITS_PER_LONG-1)));
}

int my_test_and_clear_bit(int nr, volatile unsigned long *addr)
{
	unsigned long mask = BIT_MASK(nr);
	unsigned long *p = ((unsigned long *)addr) + BIT_WORD(nr);
	unsigned long old;
//	unsigned long flags;

//	_atomic_spin_lock_irqsave(p, flags);
	old = *p;
	*p = old & ~mask;
//	_atomic_spin_unlock_irqrestore(p, flags);

	return (old & mask) != 0;
}

int my_test_and_set_bit(int nr, volatile unsigned long *addr)
{
	unsigned long mask = BIT_MASK(nr);
	unsigned long *p = ((unsigned long *)addr) + BIT_WORD(nr);
	unsigned long old;
//	unsigned long flags;

//	_atomic_spin_lock_irqsave(p, flags);
	old = *p;
	*p = old | mask;
//	_atomic_spin_unlock_irqrestore(p, flags);

	return (old & mask) != 0;
}

void my___set_bit(int nr, volatile unsigned long *addr)
{
	unsigned long mask = BIT_MASK(nr);
	unsigned long *p = ((unsigned long *)addr) + BIT_WORD(nr);

	*p  |= mask;
}

void my___clear_bit(int nr, volatile unsigned long *addr)
{
	unsigned long mask = BIT_MASK(nr);
	unsigned long *p = ((unsigned long *)addr) + BIT_WORD(nr);

	*p &= ~mask;
}

enum pageflags {
PG_locked,/* Page is locked. Don't touch. */
PG_error,
PG_referenced,
PG_uptodate,
PG_dirty,
PG_lru,
PG_active,
PG_slab,
PG_owner_priv_1,/* Owner use. If pagecache, fs may use*/
PG_arch_1,
PG_reserved,
PG_private,/* If pagecache, has fs-private data */
PG_private_2,/* If pagecache, has fs aux data */
PG_writeback,/* Page is under writeback */
PG_head,/* A head page */
PG_tail,/* A tail page */
PG_swapcache,/* Swap page: swp_entry_t in private */
PG_mappedtodisk,/* Has blocks allocated on-disk */
PG_reclaim,/* To be reclaimed asap */
PG_buddy,/* Page is free, on buddy lists */
PG_swapbacked,/* Page is backed by RAM/swap */
PG_unevictable,/* Page is "unevictable"  */
   };

typedef unsigned int	my___kernel_size_t;
typedef unsigned long my_u64;
my_u64 jiffies_64;

typedef unsigned int my_u32;
   
#define DIV_ROUND_UP(n,d) (((n) + (d) - 1) / (d))
#define BITS_PER_BYTE		8
#define BITS_TO_LONGS(nr)	DIV_ROUND_UP(nr, BITS_PER_BYTE * sizeof(long))
#define DECLARE_BITMAP(name,bits) \
	unsigned long name[BITS_TO_LONGS(bits)]

typedef struct { DECLARE_BITMAP(bits, MAX_NUMNODES); } my_nodemask_t;

typedef my___kernel_size_t		my_size_t;

typedef my_u32 my_dma_addr_t;

int my_page_group_by_mobility_disabled = 0;
#define numa_node_id()		0
#define HZ		0x64
#define ULONG_MAX	(~0UL)

typedef int (*my_initcall_t)(void);

int my_smp_processor_id(void)
{
return 0;
}

int my_cache_line_size(void)
{
return 0x20;
}


#define __GFP_RECLAIMABLE (( my_gfp_t)0x80000u) /* Page is reclaimable */
#define __GFP_NOTRACK	(( my_gfp_t)0)
#define __GFP_REPEAT	(( my_gfp_t)0x400u)	/* See above */
#define __GFP_ZERO	(( my_gfp_t)0x8000u)/* Return zeroed page on success */
#define __GFP_WAIT	(( my_gfp_t)0x10u)	/* Can wait and reschedule? */
#define __GFP_HIGH	(( my_gfp_t)0x20u)	/* Should access emergency pools? */
#define __GFP_IO	(( my_gfp_t)0x40u)	/* Can start physical IO? */
#define __GFP_FS	(( my_gfp_t)0x80u)	/* Can call down to low-level FS? */
#define __GFP_NOWARN	(( my_gfp_t)0x200u)	/* Suppress page allocation failure warning */
//#define __GFP_REPEAT	((_my__force gfp_t)0x400u)	/* See above */
#define __GFP_NOFAIL	(( my_gfp_t)0x800u)	/* See above */
#define __GFP_NORETRY	(( my_gfp_t)0x1000u)/* See above */
#define __GFP_NOMEMALLOC (( my_gfp_t)0x10000u) /* Don't use emergency reserves */

#define __GFP_HARDWALL   (( my_gfp_t)0x20000u) /* Enforce hardwall cpuset memory allocs */
#define __GFP_THISNODE	(( my_gfp_t)0x40000u)/* No fallback, no policies */
#define __GFP_MOVABLE	(( my_gfp_t)0x08u)  /* Page is movable */

#define GFP_RECLAIM_MASK (__GFP_WAIT|__GFP_HIGH|__GFP_IO|__GFP_FS|\
			__GFP_NOWARN|__GFP_REPEAT|__GFP_NOFAIL|\
			__GFP_NORETRY|__GFP_NOMEMALLOC)

#define __GFP_DMA	(( my_gfp_t)0x01u)
#define __GFP_HIGHMEM	(( my_gfp_t)0x02u)
#define __GFP_DMA32	(( my_gfp_t)0x04u)
#define __GFP_MOVABLE	(( my_gfp_t)0x08u)  /* Page is movable */
#define GFP_ZONEMASK	(__GFP_DMA|__GFP_HIGHMEM|__GFP_DMA32|__GFP_MOVABLE)
#define GFP_THISNODE	((my_gfp_t)0)

#define OPT_ZONE_HIGHMEM MY_ZONE_NORMAL
#define OPT_ZONE_DMA MY_ZONE_NORMAL
#define OPT_ZONE_DMA32 MY_ZONE_NORMAL

/* This equals 0, but use constants in case they ever change */
#define GFP_NOWAIT	(GFP_ATOMIC & ~__GFP_HIGH)
/* GFP_ATOMIC means both !wait (__GFP_WAIT not set) and use emergency pool */
#define GFP_ATOMIC	(__GFP_HIGH)

#define GFP_ZONE_TABLE ( \
	(MY_ZONE_NORMAL << 0 * ZONES_SHIFT)				\
	| (OPT_ZONE_DMA << __GFP_DMA * ZONES_SHIFT) 			\
	| (OPT_ZONE_HIGHMEM << __GFP_HIGHMEM * ZONES_SHIFT)		\
	| (OPT_ZONE_DMA32 << __GFP_DMA32 * ZONES_SHIFT)			\
	| (MY_ZONE_NORMAL << __GFP_MOVABLE * ZONES_SHIFT)			\
	| (OPT_ZONE_DMA << (__GFP_MOVABLE | __GFP_DMA) * ZONES_SHIFT)	\
	| (MY_ZONE_MOVABLE << (__GFP_MOVABLE | __GFP_HIGHMEM) * ZONES_SHIFT)\
	| (OPT_ZONE_DMA32 << (__GFP_MOVABLE | __GFP_DMA32) * ZONES_SHIFT)\
)

#define GFP_MOVABLE_MASK (__GFP_RECLAIMABLE|__GFP_MOVABLE)
#define GFP_CONSTRAINT_MASK (__GFP_HARDWALL|__GFP_THISNODE)

#define GFP_KERNEL	(__GFP_WAIT | __GFP_IO | __GFP_FS)

#define SLAB_RECLAIM_ACCOUNT	0x00020000UL		/* Objects are reclaimable */

typedef unsigned  long my_gfp_t;
my_gfp_t my_gfp_allowed_mask = 0x3ffff; ;

int 	my_pageblock_order = 11;


#define MIGRATE_UNMOVABLE     0
#define MIGRATE_RECLAIMABLE   1
#define MIGRATE_MOVABLE       2
#define MIGRATE_PCPTYPES      3 /* the number of types on the pcp lists */
#define MIGRATE_RESERVE       3

#define BITS_PER_LONG 32

#define zone_pcp(__z, __cpu) (&(__z)->pageset[(__cpu)])

//unsigned long init_mm[4096];


typedef my_u32 my_phys_addr_t;



//typedef pte_t my_pte_t;
//; } my_pte_t;
//typedef pmd_t my_pmd_t;
// } my_pmd_t;
//typedef pgd_t my_pgd_t; 
//} my_pgd_t;

typedef struct { unsigned long pte; } my_pte_t;
typedef struct { unsigned long pmd; } my_pmd_t;
typedef struct { unsigned long pgd[2]; } my_pgd_t;

#define pmd_offset(dir, addr)	((my_pmd_t *)(dir))
#define my__pmd(x)        ((my_pmd_t) { (x) } )
#define my_pmd_val(x)      ((x).pmd)

struct my_mm_struct {
	my_pgd_t * pgd;
};

#define PTRS_PER_PGD		2048

extern my_pgd_t swapper_pg_dir[PTRS_PER_PGD];

struct my_mm_struct my_init_mm = {
	.pgd		= swapper_pg_dir,
};


void my_clean_pmd_entry(my_pmd_t *pmd)
{
		asm("mcr	p15, 0, %0, c7, c10, 1	@ flush_pmd"
			: : "r" (pmd) : "cc");
		asm("mcr	p15, 1, %0, c15, c9, 1  @ L2 flush_pmd"
			: : "r" (pmd) : "cc");
}


#define MAX_ORDER 11
#define MAX_ORDER_NR_PAGES (1 << (MAX_ORDER - 1))

#define PAGE_SHIFT		12
#define PAGE_SIZE		(_AC(1,UL) << PAGE_SHIFT)
#define PAGE_MASK		(~(PAGE_SIZE-1))
#define PAGE_OFFSET		0xc0000000                 //config
#define PHYS_OFFSET		0                          // config
#define KMALLOC_SHIFT_HIGH	((MAX_ORDER + PAGE_SHIFT - 1) <= 25 ? \
				(MAX_ORDER + PAGE_SHIFT - 1) : 25)

#define KMALLOC_MAX_SIZE	(1UL << KMALLOC_SHIFT_HIGH)
#define KMALLOC_MAX_ORDER	(KMALLOC_SHIFT_HIGH - PAGE_SHIFT)

#define pageblock_order		(MAX_ORDER-1)

#define pageblock_nr_pages	(1UL << pageblock_order)

#define __AC(X,Y)	(X##Y)
#define _AC(X,Y)	__AC(X,Y)
#define UL(x) _AC(x, UL)

#define __ALIGN_MASK(x,mask)	(((x)+(mask))&~(mask))
#define ALIGN(x,a)		__ALIGN_MASK(x,(typeof(x))(a)-1)

#define virt_to_page(addr)	(my_mem_map + (((unsigned long)(addr)-PAGE_OFFSET) >> PAGE_SHIFT))
#define	__phys_to_pfn(paddr)	((paddr) >> PAGE_SHIFT)
#define my___phys_to_virt(x)	((x) - PHYS_OFFSET + PAGE_OFFSET)

#define __virt_to_phys(x)	((x) - PAGE_OFFSET + PHYS_OFFSET)
#define my__virt_to_bus	__virt_to_phys


#define	__pfn_to_phys(pfn)	((pfn) << PAGE_SHIFT)


#define my__pa(x)			__virt_to_phys((unsigned long)(x))
#define my___va(x) ((void *)((unsigned long)(x) + PAGE_OFFSET))

#define my_phys_to_virt(x)	my___va(x)



#define __pmd(x)        ((my_pmd_t) { (x) } )

#define PFN_UP(x)	(((x) + PAGE_SIZE-1) >> PAGE_SHIFT)
#define PFN_DOWN(x)	((x) >> PAGE_SHIFT)
#define PFN_PHYS(x)	((my_phys_addr_t)(x) << PAGE_SHIFT)

#define NULL ((void *)0)
#define DOMAIN_KERNEL	0
#define MAX_NR_ZONES 2 /* __MAX_NR_ZONES	@ */
#define NODE_DATA(nid)		(&my_contig_page_data)
#define ZONES_SHIFT 1

#define GFP_ZONE_TABLE ( \
	(MY_ZONE_NORMAL << 0 * ZONES_SHIFT)				\
	| (OPT_ZONE_DMA << __GFP_DMA * ZONES_SHIFT) 			\
	| (OPT_ZONE_HIGHMEM << __GFP_HIGHMEM * ZONES_SHIFT)		\
	| (OPT_ZONE_DMA32 << __GFP_DMA32 * ZONES_SHIFT)			\
	| (MY_ZONE_NORMAL << __GFP_MOVABLE * ZONES_SHIFT)			\
	| (OPT_ZONE_DMA << (__GFP_MOVABLE | __GFP_DMA) * ZONES_SHIFT)	\
	| (MY_ZONE_MOVABLE << (__GFP_MOVABLE | __GFP_HIGHMEM) * ZONES_SHIFT)\
	| (OPT_ZONE_DMA32 << (__GFP_MOVABLE | __GFP_DMA32) * ZONES_SHIFT)\
)


enum my_zone_type {
#ifdef CONFIG_ZONE_DMA
	MY_ZONE_DMA,
#endif
#ifdef CONFIG_ZONE_DMA32
	MY_ZONE_DMA32,
#endif
	MY_ZONE_NORMAL,
#ifdef CONFIG_HIGHMEM
	MY_ZONE_HIGHMEM,
#endif
	MY_ZONE_MOVABLE,
	MY___MAX_NR_ZONES
};
                                  
enum my_zone_type my_gfp_zone(my_gfp_t flags)
{
	enum my_zone_type z;
	int bit = flags & GFP_ZONEMASK;

	z = (GFP_ZONE_TABLE >> (bit * ZONES_SHIFT)) &
					 ((1 << ZONES_SHIFT) - 1);

	return z;
}

int my_allocflags_to_migratetype(my_gfp_t gfp_flags)
{
//	WARN_ON((gfp_flags & GFP_MOVABLE_MASK) == GFP_MOVABLE_MASK);

	if (my_page_group_by_mobility_disabled)
		return MIGRATE_UNMOVABLE;

	/* Group based on mobility */
	return (((gfp_flags & __GFP_MOVABLE) != 0) << 1) |
		((gfp_flags & __GFP_RECLAIMABLE) != 0);
}



#define LIST_HEAD_INIT(name) { &(name), &(name) }

#define offsetof(TYPE, MEMBER) ((my_size_t) &((TYPE *)0)->MEMBER)

#define container_of(ptr, type, member) ({			\
	const typeof( ((type *)0)->member ) *__mptr = (ptr);	\
	(type *)( (char *)__mptr - offsetof(type,member) );})

#define list_entry(ptr, type, member) \
	container_of(ptr, type, member)

#define list_for_each_entry(pos, head, member)				\
	for (pos = list_entry((head)->next, typeof(*pos), member);	\
	     &pos->member != (head); 	\
	     pos = list_entry(pos->member.next, typeof(*pos), member))

void MY_INIT_LIST_HEAD(struct my_list_head *list)
{
	list->next = list;
	list->prev = list;
}

void my_list_add(struct my_list_head *new, struct my_list_head *head)
{
	struct my_list_head *prev;
	struct my_list_head *next;
	next = head->next; 
        prev = head;
	next->prev = new;
	new->next = next;
	new->prev = prev;
	prev->next = new;
}
void my_list_add_tail(struct my_list_head *new, struct my_list_head *head)
{
//	__list_add(new, head->prev, head);
	struct my_list_head *prev;
	struct my_list_head *next;
	next = head;
        prev = head->prev;
	next->prev = new;
	new->next = next;
	new->prev = prev;
	prev->next = new;

}
void my_list_del(struct my_list_head * e)
{
	struct my_list_head * prev = e->prev;
	 struct my_list_head * next = e->next;
	next->prev = prev;
	prev->next = next;
}

int my_list_empty(const struct my_list_head *head)
{
	return head->next == head;
}


#define pgoff_t unsigned long
#define L1_CACHE_BYTES		0x20
#define ARCH_KMALLOC_MINALIGN	L1_CACHE_BYTES
#define SLAB_HWCACHE_ALIGN	0x00002000UL	/* Align objs on cache lines */
#define SLAB_PANIC		0x00040000UL	/* Panic if kmem_cache_create() fails */

#define SMP_CACHE_BYTES L1_CACHE_BYTES

#define __pfn_to_page(pfn)	(my_mem_map + ((pfn)))
#define __page_to_pfn(page)	((unsigned long)((page) - my_mem_map))

#define pfn_to_page __pfn_to_page
#define page_to_pfn __page_to_pfn

enum my_pageblock_bits {
	MY_PB_migrate,
	MY_PB_migrate_end = MY_PB_migrate + 3 - 1,
			/* 3 bits required for migrate types */
	MY_NR_PAGEBLOCK_BITS
};
#define MY_RB_ROOT	(struct my_rb_root) { NULL, }
#define	rb_entry(ptr, type, member) container_of(ptr, type, member)

struct my_rb_node
{
	unsigned long  rb_parent_color;
#define	RB_RED		0
#define	RB_BLACK	1
	struct my_rb_node *rb_right;
	struct my_rb_node *rb_left;
};

#define rb_parent(r)   ((struct my_rb_node *)((r)->rb_parent_color & ~3))
struct my_rb_node *my_rb_next(const struct my_rb_node *node)
{
	struct my_rb_node *parent;

	if (rb_parent(node) == node)
		return NULL;

	/* If we have a right-hand child, go down and then left as far
	   as we can. */
	if (node->rb_right) {
		node = node->rb_right; 
		while (node->rb_left)
			node=node->rb_left;
		return (struct rb_node *)node;
	}

	while ((parent = rb_parent(node)) && node == parent->rb_right)
		node = parent;

	return parent;
}

struct my_rb_root
{
	struct my_rb_node *rb_node;
};



int my_gfp_zonelist(my_gfp_t flags)
{
//	if (NUMA_BUILD && (flags & __GFP_THISNODE))
//		return 1;

	return 0;
}

typedef struct my_pglist_data {
	struct my_zone node_zones[MAX_NR_ZONES];
	struct my_zonelist node_zonelists[MAX_ZONELISTS];
	int nr_zones;
//#ifdef CONFIG_FLAT_NODE_MEM_MAP	/* means !SPARSEMEM */
	struct my_page *node_mem_map;
#ifdef CONFIG_CGROUP_MEM_RES_CTLR
	struct page_cgroup *node_page_cgroup;
#endif
//#endif
	struct bootmem_data *bdata;
#ifdef CONFIG_MEMORY_HOTPLUG
//	spinlock_t node_size_lock;
#endif
	unsigned long node_start_pfn;
	unsigned long node_present_pages; /* total number of physical pages */
	unsigned long node_spanned_pages; /* total size of physical page
					     range, including holes */
	int node_id;
//	wait_queue_head_t kswapd_wait;
//	struct task_struct *kswapd;
	int kswapd_max_order;
} my_pg_data_t;

struct pglist_data;

typedef struct my_bootmem_data {
	unsigned long node_min_pfn;
	unsigned long node_low_pfn;
	void *node_bootmem_map;
	unsigned long last_end_off;
	unsigned long hint_idx;
	struct my_list_head list;
} my_bootmem_data_t;

my_bootmem_data_t my_bootmem_node_data[MAX_NUMNODES];
struct pglist_data my_contig_page_data = { .bdata = &my_bootmem_node_data[0] };
//struct pglist_data my_contig_page_data;
//extern struct pglist_data contig_page_data;

struct my_zonelist *my_node_zonelist(int nid, my_gfp_t flags)
{
	return NODE_DATA(nid)->node_zonelists + my_gfp_zonelist(flags);

//	return (&contig_page_data)->node_zonelists + my_gfp_zonelist(flags);
}

#define zone_idx(zone)		((zone) - (zone)->zone_pgdat->node_zones)

enum my_pageflags {
MY_PG_locked,/* Page is locked. Don't touch. */
MY_PG_error,
MY_PG_referenced,
MY_PG_uptodate,
MY_PG_dirty,
MY_PG_lru,
MY_PG_active,
MY_PG_slab,
MY_PG_owner_priv_1,/* Owner use. If pagecache, fs may use*/
MY_PG_arch_1,
MY_PG_reserved,
MY_PG_private,/* If pagecache, has fs-private data */
MY_PG_private_2,/* If pagecache, has fs aux data */
MY_PG_writeback,/* Page is under writeback */
MY_PG_head,/* A head page */
MY_PG_tail,/* A tail page */
MY_PG_swapcache,/* Swap page: swp_entry_t in private */
MY_PG_mappedtodisk,/* Has blocks allocated on-disk */
MY_PG_reclaim,/* To be reclaimed asap */
MY_PG_buddy,/* Page is free, on buddy lists */
MY_PG_swapbacked,/* Page is backed by RAM/swap */
MY_PG_unevictable,/* Page is "unevictable"  */
};




#define PMD_TYPE_TABLE		(1 << 0)
#define L_PTE_PRESENT		(1 << 0)
#define L_PTE_YOUNG		(1 << 1)
#define L_PTE_DIRTY		(1 << 6)
#define L_PTE_WRITE		(1 << 7)
#define L_PTE_SHARED		(1 << 10)	/* shared(v6), coherent(xsc3) */
#define L_PTE_MT_DEV_SHARED	(0x04 << 2)	/* 0100 */
#define VMALLOC_END		(PAGE_OFFSET + 0x18000000) // Versatile

#define PMD_DOMAIN(x)		((x) << 5)
#define PMD_BIT4		(1 << 4)

#define PGDIR_SHIFT		21
#define PGDIR_SIZE		(1UL << PGDIR_SHIFT)
#define PGDIR_MASK		(~(PGDIR_SIZE-1))
#define PTRS_PER_PTE		512

#define NODES_WIDTH		0
#define SECTIONS_WIDTH		0
#define SECTIONS_PGOFF		((sizeof(unsigned long)*8) - SECTIONS_WIDTH)
#define NODES_PGOFF		(SECTIONS_PGOFF - NODES_WIDTH)

#define PAGE_ALIGN(addr) ALIGN(addr, PAGE_SIZE)

#define pgd_index(addr)		((addr) >> PGDIR_SHIFT)
#define pgd_offset(mm, addr)	((mm)->pgd+pgd_index(addr))
#define pgd_offset_k(addr)	pgd_offset(&my_init_mm, addr)

#define __pte_index(addr)	(((addr) >> PAGE_SHIFT) & (PTRS_PER_PTE - 1))

void * my_high_memory;

#define pgd_addr_end(addr, end)						\
({	unsigned long __boundary = ((addr) + PGDIR_SIZE) & PGDIR_MASK;	\
	(__boundary - 1 < (end) - 1)? __boundary: (end);		\
})

#define VMALLOC_OFFSET		(8*1024*1024)
#define VMALLOC_START		(((unsigned long)my_high_memory + VMALLOC_OFFSET) & ~(VMALLOC_OFFSET-1))
                        

//		pmd_clear(pmd_offset(pgd_offset_k(addr), addr));
//#define pmd_offset(dir, addr)	((my_pmd_t *)(dir))
//#define pgd_index(addr)		((addr) >> PGDIR_SHIFT)
//#define pgd_offset(mm, addr)	((mm)->pgd+pgd_index(addr))
//#define pgd_offset_k(addr)	pgd_offset(&init_mm, addr)

#define pmd_clear(pmdp)			\
	do {				\
		pmdp[0] = __pmd(0);	\
		pmdp[1] = __pmd(0);	\
		my_clean_pmd_entry(pmdp);	\
	} while (0)

#define SECTION_SHIFT		20
#define SECTION_SIZE		(1UL << SECTION_SHIFT)
#define SECTION_MASK		(~(SECTION_SIZE-1))

#define ZONES_WIDTH		ZONES_SHIFT
#define ZONES_PGOFF		(NODES_PGOFF - ZONES_WIDTH)
#define ZONES_PGSHIFT		(ZONES_PGOFF * (ZONES_WIDTH != 0))
#define ZONES_MASK		((1UL << ZONES_WIDTH) - 1)

#define set_page_private(page, v)	((page)->private = (v))
#define page_private(page)		((page)->private)
#define page_address(page) __va(page_to_pfn(page) << PAGE_SHIFT)
#define my_page_address(page) my___va(page_to_pfn(page) << PAGE_SHIFT)

#define BOOTMEM_DEFAULT		0
#define MAX_DMA_ADDRESS	0xffffffff

typedef struct bootmem_data {
	unsigned long node_min_pfn;
	unsigned long node_low_pfn;
	void *node_bootmem_map;
	unsigned long last_end_off;
	unsigned long hint_idx;
	struct my_list_head list;
} bootmem_data_t;

#define VM_IOREMAP	0x00000001

struct vm_struct {
	struct vm_struct	*next;
	void			*addr;
	unsigned long		size;
	unsigned long		flags;
	struct my_page		**pages;
	unsigned int		nr_pages;
	unsigned long		phys_addr;
	void			*caller;
};

#define MT_DEVICE		0
#define writel(v,a)       (*(volatile unsigned long  *)(a) = (v))

//#include <asm/tlbflush.h>
struct my_page *my_mem_map;
//extern struct my_page *mem_map;

#define CONSISTENT_DMA_SIZE 	0x200000

struct my_array_cache {
	unsigned int avail;
	unsigned int limit;
	unsigned int batchcount;
	unsigned int touched;
//	spinlock_t lock;
	void *entry[];	
    };

struct my_kmem_list3 {
		struct my_list_head slabs_partial;	/* partial list first, better asm code */
		struct my_list_head slabs_full;
		struct my_list_head slabs_free;
		unsigned long free_objects;
		unsigned int free_limit;
		unsigned int colour_next;	/* Per-node cache coloring */
//		spinlock_t list_lock;
		struct my_array_cache *shared;	/* shared per node */
		struct my_array_cache **alien;	/* on other nodes */
		unsigned long next_reap;	/* updated without locking */
		int free_touched;		/* updated without locking */
	};

struct my_kmem_cache {
/* 1) per-cpu data, touched during every alloc/free */
	struct my_array_cache *array[NR_CPUS];
/* 2) Cache tunables. Protected by cache_chain_mutex */
	unsigned int batchcount;
	unsigned int limit;
	unsigned int shared;

	unsigned int buffer_size;
	my_u32 reciprocal_buffer_size;
/* 3) touched by every alloc & free from the backend */

	unsigned int flags;		/* constant flags */
	unsigned int num;		/* # of objs per slab */

/* 4) cache_grow/shrink */
	/* order of pgs per slab (2^n) */
	unsigned int gfporder;

	/* force GFP flags, e.g. GFP_DMA */
	my_gfp_t gfpflags;

	my_size_t colour;			/* cache colouring range */
	unsigned int colour_off;	/* colour offset */
	struct my_kmem_cache *slabp_cache;
	unsigned int slab_size;
	unsigned int dflags;		/* dynamic flags */

	/* constructor func */
//	void (*ctor)(void *obj);

/* 5) cache creation/removal */
	const char *name;
	struct my_list_head next;

/* 6) statistics */

	/*
	 * We put nodelists[] at the end of kmem_cache, because we want to size
	 * this array to nr_node_ids slots instead of MAX_NUMNODES
	 * (see kmem_cache_init())
	 * We still use [MAX_NUMNODES] and not [1] or [0] because cache_cache
	 * is statically defined, so we reserve the max number of nodes.
	 */
	struct my_kmem_list3 *nodelists[MAX_NUMNODES];
	/*
	 * Do not add fields after nodelists[]
	 */
};

struct my_cache_sizes {
	my_size_t		 	cs_size;
	struct my_kmem_cache	*cs_cachep;
//#ifdef CONFIG_ZONE_DMA
//	struct kmem_cache	*cs_dmacachep;
//#endif
};


struct my_cache_sizes my_malloc_sizes[] = {
#define CACHE(x) { .cs_size = (x) },
#include "kmalloc_sizes.h"
	CACHE(ULONG_MAX)
#undef CACHE
};

struct membank {
	unsigned long start;
	unsigned long size;
	unsigned short node;
	unsigned short highmem;
};

#define NR_BANKS 8

struct meminfo {
	int nr_banks;
	struct membank bank[NR_BANKS];
};
struct meminfo my_meminfo;

#define bank_pfn_start(bank)	__phys_to_pfn((bank)->start)
#define bank_pfn_end(bank)	__phys_to_pfn((bank)->start + (bank)->size)
#define bank_pfn_size(bank)	((bank)->size >> PAGE_SHIFT)
#define bank_phys_start(bank)	(bank)->start
#define bank_phys_end(bank)	((bank)->start + (bank)->size)
#define bank_phys_size(bank)	(bank)->size


extern char _stext[]; 
extern char _end[];

enum my_system_states {
	MY_SYSTEM_BOOTING,
	MY_SYSTEM_RUNNING,
	MY_SYSTEM_HALT,
	MY_SYSTEM_POWER_OFF,
	MY_SYSTEM_RESTART,
	MY_SYSTEM_SUSPEND_DISK,
} system_state;

//enum system_states system_state;
char *saved_command_line;
char * envp_init[256] = { "HOME=/", "TERM=linux", NULL, };

unsigned long loops_per_jiffy = (1<<12);
void  parse_early_options(char *cmdline)
{
}
#define NUM_CONSISTENT_PTES (CONSISTENT_DMA_SIZE >> PGDIR_SHIFT)

struct map_desc {
	unsigned long virtual;
	unsigned long pfn;
	unsigned long length;
	unsigned int type;
};

#define MT_MEMORY		9

struct mem_type {
	unsigned int prot_pte;
	unsigned int prot_l1;
	unsigned int prot_sect;
	unsigned int domain;
};

#define PMD_TYPE_SECT		(2 << 0)
#define PMD_SECT_AP_WRITE	(1 << 10)

struct mem_type my_mem_types[] = {
	[MT_MEMORY] = {
		.prot_sect = PMD_TYPE_SECT | PMD_SECT_AP_WRITE,
		.domain    = DOMAIN_KERNEL,
	},
};

void  my2_bootmem_init(void)
{
//	my_mem_map = mem_map;
//	my_contig_page_data = contig_page_data;
//	my_contig_page_data = 0xb4;
	struct meminfo *mi = &my_meminfo;
	unsigned long min, max_low, max_high;
	int node = 0;
	unsigned long node_low, node_high;
	unsigned long *my_min = &min; 
	unsigned long *my_max_low = &node_low; 
	unsigned long *my_max_high = &node_high;
	unsigned long start_pfn;
	unsigned long end_pfn;
	unsigned long boot_pfn;
	unsigned int boot_pages;
	struct map_desc *md;
	unsigned long phys, addr, length, end;
	unsigned long bytes;
	unsigned int bootmap_pages;
	const struct mem_type *type;
	unsigned int mstart_pfn, bootmap_pfn;
	unsigned long mapstart; 
	unsigned long start;
	unsigned long sidx, eidx;
	unsigned long idx;


	my_pgd_t *pgd;
	bootmem_data_t *bdata;;

	my_pg_data_t *pgdat;

	int i;

	max_low = max_high = 0;
	*my_min = -1UL;
	*my_max_low = *my_max_high = 0;

        for (i = 0; i < (mi)->nr_banks; i++)
	    if ((mi)->bank[i].node == node){

		struct membank *bank = &mi->bank[i];
		unsigned long start, end;

		start = bank_pfn_start(bank);
		end = bank_pfn_end(bank);

		if (*my_min > start)
			*my_min = start;
		if (*my_max_high < end)
			*my_max_high = end;
		if (bank->highmem)
			continue;
		if (*my_max_low < end)
			*my_max_low = end;
	}

	start_pfn=min;
	end_pfn=node_low;
        for (i = 0; i < (mi)->nr_banks; i++)
	    if ((mi)->bank[i].node == node){
		struct membank *bank = &mi->bank[i];

		if (!bank->highmem)
		{
			struct map_desc map;
                	map.pfn = bank_pfn_start(bank);
			map.virtual = my_phys_to_virt(bank_phys_start(bank));
			map.length = bank_phys_size(bank);
			map.type = MT_MEMORY;
			md = &map;
			type = &my_mem_types[md->type];
			addr = md->virtual & PAGE_MASK;
			phys = (unsigned long)__pfn_to_phys(md->pfn);
			length = PAGE_ALIGN(md->length + (md->virtual & ~PAGE_MASK));
			pgd = pgd_offset_k(addr);
			end = addr + length;
			do {
			    unsigned long next = pgd_addr_end(addr, end);
		            unsigned long maddr = addr;
		            unsigned long end =next; 
            		    unsigned long mphys=phys;
                	    my_pmd_t *pmd = pmd_offset(pgd, addr);
                    	    if (((addr | end | phys) & ~SECTION_MASK) == 0) {
                    		if (addr & SECTION_SIZE) pmd++;
                    		do {
                    		    (*pmd).pmd = mphys | type->prot_sect;
                    		    mphys += SECTION_SIZE;
                    		} while (pmd++, maddr += SECTION_SIZE, maddr != end);
                            }
                        phys += next - addr;
                        addr = next;
                        } while (pgd++, addr != end);
                }
	}
	bytes = (end_pfn - start_pfn + 7) / 8;
	bytes = ALIGN(bytes, sizeof(long));
        boot_pages = PAGE_ALIGN(bytes) >> PAGE_SHIFT;
	bootmap_pages = boot_pages;

	mstart_pfn   = PAGE_ALIGN(my__pa(_end)) >> PAGE_SHIFT;
	bootmap_pfn = 0;

  for (i = 0; i < (mi)->nr_banks; i++)
	    if ((mi)->bank[i].node == node){
		struct membank *bank = &mi->bank[i];
		unsigned int start, end;
		start = __phys_to_pfn(bank->start);
		end   = __phys_to_pfn(bank->start+bank->size);

		if (end < mstart_pfn)
			continue;

		if (start < mstart_pfn)
			start = mstart_pfn;

		if (end <= start)
			continue;

		if (end - start >= bootmap_pages) {
			bootmap_pfn = start;
			break;
		}
  }
  boot_pfn = bootmap_pfn;
  pgdat = NODE_DATA(0);
  bdata = NODE_DATA(0)->bdata;
  mapstart=boot_pfn; 
  start=start_pfn;
  end = end_pfn;
  bdata->node_bootmem_map = my_phys_to_virt(PFN_PHYS(mapstart));
  bdata->node_min_pfn = start;
  bdata->node_low_pfn = end;

    for (i = 0; i < (mi)->nr_banks; i++)
	    if ((mi)->bank[i].node == node){
		struct membank *bank = &mi->bank[i];
			unsigned long physaddr = bank->start;
			unsigned long size = bank->size;

                        start = PFN_DOWN(physaddr);
			end = PFN_UP(physaddr + size);

			sidx = start - NODE_DATA(0)->bdata->node_min_pfn;
			eidx = end - NODE_DATA(0)->bdata->node_min_pfn;

                        for (idx = sidx; idx < eidx; idx++)
                    	    my_test_and_clear_bit(idx, NODE_DATA(0)->bdata->node_bootmem_map);
	}
	unsigned long physaddr = my__pa(_stext);
	unsigned long size = _end - _stext;
	start = PFN_DOWN(physaddr);
	end = PFN_UP(physaddr + size);
	sidx = start - NODE_DATA(0)->bdata->node_min_pfn;
	eidx = end - NODE_DATA(0)->bdata->node_min_pfn;

	unsigned long midx;
	for (midx = sidx; midx < eidx; midx++)
		my_test_and_set_bit(midx, NODE_DATA(0)->bdata->node_bootmem_map);

	unsigned long zone_size[MY___MAX_NR_ZONES], zhole_size[MY___MAX_NR_ZONES];
	my_max_low = &max_low; 
	my_max_high = &max_high;

	*my_min = -1UL;
	*my_max_low = *my_max_high = 0;

        for (i = 0; i < (mi)->nr_banks; i++)
	    if ((mi)->bank[i].node == node){

		struct membank *bank = &mi->bank[i];
		unsigned long start, end;

		start = bank_pfn_start(bank);
		end = bank_pfn_end(bank);

		if (*my_min > start)
			*my_min = start;
		if (*my_max_high < end)
			*my_max_high = end;
		if (bank->highmem)
			continue;
		if (*my_max_low < end)
			*my_max_low = end;
	}
//        extern memset(unsigned long a, unsigned long b, unsigned long c);
//        extern memcpy(unsigned long a, unsigned long b, unsigned long c);

	my_memset(zone_size, 0, sizeof(zone_size));
	zone_size[0] = max_low - min;
	my_memcpy(zhole_size, zone_size, sizeof(zhole_size));
	idx = 0;
	zhole_size[idx] -= bank_pfn_size(&mi->bank[0]);
	int nid=0;
	unsigned long *zones_size = zone_size;
	unsigned long node_start_pfn = min;
	pgdat = NODE_DATA(nid);
	pgdat->node_id = nid;
	pgdat->node_start_pfn = node_start_pfn;
        unsigned long totalpages = 0;
	enum my_zone_type zt;
        for (zt = 0; zt < MY___MAX_NR_ZONES; zt++)
	    totalpages += zones_size[zt];
	pgdat->node_spanned_pages = totalpages;

	if (!pgdat->node_mem_map) {
	    unsigned long size, start, end;
	    struct my_page *map = NULL;
	    start = pgdat->node_start_pfn & ~(MAX_ORDER_NR_PAGES - 1);
	    end = pgdat->node_start_pfn + pgdat->node_spanned_pages;
	    end = ALIGN(end, MAX_ORDER_NR_PAGES);
	    size =  (end - start) * sizeof(struct my_page);
	    struct bootmem_data *bdata = pgdat->bdata;
	    unsigned long align=SMP_CACHE_BYTES;
	    unsigned long goal=my__pa(MAX_DMA_ADDRESS);
	    unsigned long limit = 0;
	    unsigned long fallback = 0;
	    unsigned long min, max, sidx, midx, step;
	    min = bdata->node_min_pfn;
	    max = bdata->node_low_pfn;
	    goal >>= PAGE_SHIFT;
	    limit >>= PAGE_SHIFT;
	    if (limit && max > limit)
		max = limit;
	    step = max(align >> PAGE_SHIFT, 1UL);
	    if (goal && min < goal && goal < max)
		start = ALIGN(goal, step);
	    else
		start = ALIGN(min, step);
	    sidx = start - bdata->node_min_pfn;
	    midx = max - bdata->node_min_pfn;
	    if (bdata->hint_idx > sidx) {
		fallback = sidx + 1;
		sidx = ALIGN(bdata->node_min_pfn + bdata->hint_idx, step) - bdata->node_min_pfn;
	    }
	while (1) {
	    int merge;
	    void *region;
	    unsigned long eidx, i, start_off, end_off;
find_block:
	    eidx = 0;
	    sidx = my__find_next_zero_bit_le(bdata->node_bootmem_map, midx, sidx);
	    sidx = ALIGN(bdata->node_min_pfn + sidx, step) - bdata->node_min_pfn;
	    eidx = sidx + PFN_UP(size);
	    if (sidx >= midx || eidx > midx)
		    break;
	    for (i = sidx; i < eidx; i++)
		if (my_test_bit(i, bdata->node_bootmem_map)) {
		    sidx = ALIGN(bdata->node_min_pfn + i, step) - bdata->node_min_pfn;
		    if (sidx == i) sidx += step;
		    goto find_block;
		    
		}
	    if (bdata->last_end_off & (PAGE_SIZE - 1) &&
		PFN_DOWN(bdata->last_end_off) + 1 == sidx)
		    start_off = ALIGN(PFN_PHYS(bdata->node_min_pfn) +  bdata->last_end_off, align) - PFN_PHYS(bdata->node_min_pfn);
	    else
		start_off = PFN_PHYS(sidx);
	    merge = PFN_DOWN(start_off) < sidx;
	    end_off = start_off + size;
	    bdata->last_end_off = end_off;
	    bdata->hint_idx = PFN_UP(end_off);
	    region = my_phys_to_virt(PFN_PHYS(bdata->node_min_pfn) +start_off);
	    my_memset(region, 0, size);
	    map = region;
	    break;
	}
    pgdat->node_mem_map = map + (pgdat->node_start_pfn - start);
    }
    my_mem_map = NODE_DATA(0)->node_mem_map;
    enum my_zone_type j;
    unsigned long zone_start_pfn = pgdat->node_start_pfn;
    for (j = 0; j < MY___MAX_NR_ZONES; j++) {
	struct my_zone *zone = pgdat->node_zones + j;
	unsigned long size;
	size = zone->spanned_pages = zones_size[j];
	zone->present_pages = size - 0;
	zone->zone_pgdat = pgdat;
	struct my_per_cpu_pageset *p=&zone->pageset[0]; 
	struct my_per_cpu_pages *pcp;
	int migratetype;
	my_memset(p, 0, sizeof(*p));
	pcp = &p->pcp;
	pcp->count = 0;
	pcp->batch = 1UL;
	for (migratetype = 0; migratetype < MIGRATE_PCPTYPES; migratetype++)
	    MY_INIT_LIST_HEAD(&pcp->lists[migratetype]);
        struct pglist_data *pgdat = zone->zone_pgdat;
	pgdat->nr_zones = (zone) - (zone)->zone_pgdat->node_zones + 1;
//	pgdat->nr_zones = zone_idx(zone) + 1;
	zone->zone_start_pfn = zone_start_pfn;
	int order, type;
	for (order = 0; order < MAX_ORDER; order++)
    	    for (type = 0; type < MIGRATE_TYPES; type++){
    	    MY_INIT_LIST_HEAD(&zone->free_area[order].free_list[type]);
    	    zone->free_area[order].nr_free = 0;
        }
     //memmap_init(size, nid, j, );
     {
        unsigned long zone=j;
        unsigned long start_pfn=zone_start_pfn;
        struct my_page *page;
        unsigned long end_pfn = start_pfn + size;
        unsigned long pfn;
        struct my_zone *z;
        z = &NODE_DATA(nid)->node_zones[zone];
        for (pfn = start_pfn; pfn < end_pfn; pfn++) {
    	    page = pfn_to_page(pfn);
    	    (&(page)->_mapcount)->counter= -1;
    	    int start_bitidx = MY_PB_migrate;
    	    int end_bitidx = MY_PB_migrate_end;
    	    struct my_zone *zone;
    	    unsigned long *bitmap;
    	    unsigned long pfn, bitidx;
    	    unsigned long value = 1;
    	    zone = &NODE_DATA(0)->node_zones[(page->flags >> ZONES_PGSHIFT) & ZONES_MASK];
    	    pfn = page_to_pfn(page);
    	    bitmap = zone->pageblock_flags;
    	    pfn = pfn - zone->zone_start_pfn;
    	    bitidx =  (pfn >> my_pageblock_order) * MY_NR_PAGEBLOCK_BITS;
    	    for (; start_bitidx <= end_bitidx; start_bitidx++, value <<= 1)
        	my___set_bit(bitidx + start_bitidx, bitmap);
           }
        }
    }

	bdata = pgdat->bdata; 
	int aligned;
	struct my_page *page;
	unsigned long  count = 0;

	start = bdata->node_min_pfn;
	end = bdata->node_low_pfn;
	aligned = !(start & (BITS_PER_LONG - 1));

	while (start < end) {
		unsigned long *map, idx, vec;

		map = bdata->node_bootmem_map;
		idx = start - bdata->node_min_pfn;
		vec = ~map[idx / BITS_PER_LONG];
		vec = ~0UL;
		unsigned long off = 0;
                while (vec && off < BITS_PER_LONG) { 
            	    if (vec & 1) {
			page = pfn_to_page(start + off);
			my___clear_bit(MY_PG_reserved, &page->flags);
			(&page->_count)->counter= 0;
                        struct my_zone *zone =  &NODE_DATA(0)->node_zones[(page->flags >> ZONES_PGSHIFT) & ZONES_MASK];
                        struct my_per_cpu_pages *pcp;
                        unsigned long flags;
                        int migratetype;
                        pcp = &zone_pcp(zone, 0)->pcp;
			int start_bitidx = MY_PB_migrate;
			int end_bitidx = MY_PB_migrate_end;
			unsigned long *bitmap;
			unsigned long pfn, bitidx;
			flags = 0;
			unsigned long value = 1;
			pfn = page_to_pfn(page);
			bitmap = zone->pageblock_flags;
			pfn = pfn - zone->zone_start_pfn;
	    		bitidx =  (pfn >> my_pageblock_order) * MY_NR_PAGEBLOCK_BITS;
			for (; start_bitidx <= end_bitidx; start_bitidx++, value <<= 1)
			if (my_test_bit(bitidx + start_bitidx, bitmap))
			flags |= value;
			migratetype = flags;
                        set_page_private(page, migratetype);
                        if (migratetype >= MIGRATE_PCPTYPES) {
                    	    migratetype = MIGRATE_MOVABLE;
                        }
                        my_list_add(&page->lru, &pcp->lists[migratetype]);
                        pcp->count++;
                        if (pcp->count >= pcp->high) {
			    int count=pcp->batch;
			    int migratetype = 0;
			    int batch_free = 0;
			    zone->pages_scanned = 0;
			    while (count) {
				struct my_page *page;
				struct my_list_head *list;
				    do {
					batch_free++;
					if (++migratetype == MIGRATE_PCPTYPES)
						migratetype = 0;
					list = &pcp->lists[migratetype];
				    } while (my_list_empty(list));
				    do {
					page = list_entry(list->prev, struct my_page, lru);
					my_list_del(&page->lru);
					unsigned int order=0;
					unsigned long page_idx;
					page_idx = page_to_pfn(page) & ((1 << MAX_ORDER) - 1);
					while (order < MAX_ORDER-1) {
					    unsigned long combined_idx;
					    struct my_page *buddy;
					    unsigned long buddy_idx = page_idx ^ (1 << order);
					    buddy = page + (buddy_idx - page_idx);
					    if (!(my_test_bit(MY_PG_buddy, &buddy->flags) && page_private(buddy) == order)) break;
					    my_list_del(&buddy->lru);
					    zone->free_area[order].nr_free--;
					    my___clear_bit(MY_PG_buddy, &buddy->flags);
					    set_page_private(buddy, 0);
					    combined_idx = page_idx & ~(1 << order);
					    page = page + (combined_idx - page_idx);
					    page_idx = combined_idx;
					    order++;
					}
				    set_page_private(page, order);
				    my___set_bit(MY_PG_buddy, &page->flags);
				    my_list_add(&page->lru, &zone->free_area[order].free_list[migratetype]);
				    zone->free_area[order].nr_free++;
				} while (--count && --batch_free && !my_list_empty(list));
			    }
                        pcp->count -= pcp->batch;
                        }
                    count++;
		}
		vec >>= 1;
		off++;
	    }
	    start += BITS_PER_LONG;
	}

}

void my2_build_all_zonelists(void)
{
	my_pg_data_t *pgdat = NODE_DATA(0);
	struct my_zonelist *zonelist;
	zonelist = &pgdat->node_zonelists[0];
	int nr_zones=0;
	enum my_zone_type zone_type = MY___MAX_NR_ZONES - 1;
	struct my_zone *zone;
	zone_type++;

	do {
		zone_type--;
		zone = pgdat->node_zones + zone_type;
	        (&zonelist->_zonerefs[nr_zones])->zone = zone;
//		(&zonelist->_zonerefs[nr_zones])->zone_idx = zone_idx(zone);
		(&zonelist->_zonerefs[nr_zones])->zone_idx =(zone) - (zone)->zone_pgdat->node_zones;
                nr_zones++;
	} while (zone_type);


}

#define NUM_INIT_LISTS (3 * MAX_NUMNODES)
#define	CACHE_CACHE 0
#define	SIZE_AC MAX_NUMNODES
#define	SIZE_L3 (2 * MAX_NUMNODES)

struct kmem_list3 {
		struct my_list_head slabs_partial;	/* partial list first, better asm code */
		struct my_list_head slabs_full;
		struct my_list_head slabs_free;
		unsigned long free_objects;
		unsigned int free_limit;
		unsigned int colour_next;	/* Per-node cache coloring */
//		spinlock_t list_lock;
		struct my_array_cache *shared;	/* shared per node */
		struct my_array_cache **alien;	/* on other nodes */
		unsigned long next_reap;	/* updated without locking */
		int free_touched;		/* updated without locking */
	};


struct my_kmem_cache my_cache_cache = {
	.batchcount = 1,
	.limit = 1,
	.shared = 1,
	.buffer_size = sizeof(struct my_kmem_cache),
	.name = "kmem_cache",
};

struct kmem_list3  my_initkmem_list3[NUM_INIT_LISTS];

#define REAPTIMEOUT_LIST3	(4*HZ)
struct my_list_head my_cache_chain;

#define BOOT_CPUCACHE_ENTRIES	1
				    	    	    	     
struct arraycache_init {
	struct my_array_cache cache;
	void *entries[BOOT_CPUCACHE_ENTRIES];
};


#define BOOT_CPUCACHE_ENTRIES	1

struct arraycache_init my_initarray_cache  =
    { {0, BOOT_CPUCACHE_ENTRIES, 1, 0} };
struct arraycache_init my_initarray_generic =
    { {0, BOOT_CPUCACHE_ENTRIES, 1, 0} };

#define CFLGS_OFF_SLAB		(0x80000000UL)
typedef unsigned int kmem_bufctl_t;
#define	SLAB_LIMIT	(((kmem_bufctl_t)(~0U))-3)
#define BUFCTL_END	(((kmem_bufctl_t)(~0U))-0)

struct cache_names {
    char *name;
	char *name_dma;
	};

struct cache_names  my_cache_names[] = {
#define CACHE(x) { .name = "size-" #x, .name_dma = "size-" #x "(DMA)" },
#include "kmalloc_sizes.h"
	{NULL,}
#undef CACHE
};

int slab_early_init = 1;
#define ARCH_KMALLOC_FLAGS SLAB_HWCACHE_ALIGN
#define	BYTES_PER_WORD		sizeof(void *)
#define BATCHREFILL_LIMIT	16
struct slab {
    struct my_list_head list;
	unsigned long colouroff;
	void *s_mem;		/* including colour offset */
	unsigned int inuse;	/* num of objs active in slab */
        kmem_bufctl_t free;
	unsigned short nodeid;
    };

static enum {
	NONE,
	PARTIAL_AC,
        PARTIAL_L3,
	EARLY,
        FULL
    } g_cpucache_up;


int my_fallbacks[MIGRATE_TYPES][MIGRATE_TYPES-1] = {
	[MIGRATE_UNMOVABLE]   = { MIGRATE_RECLAIMABLE, MIGRATE_MOVABLE,   MIGRATE_RESERVE },
	[MIGRATE_RECLAIMABLE] = { MIGRATE_UNMOVABLE,   MIGRATE_MOVABLE,   MIGRATE_RESERVE },
	[MIGRATE_MOVABLE]     = { MIGRATE_RECLAIMABLE, MIGRATE_UNMOVABLE, MIGRATE_RESERVE },
	[MIGRATE_RESERVE]     = { MIGRATE_RESERVE,     MIGRATE_RESERVE,   MIGRATE_RESERVE }, /* Never used */
};

void *my2_kmem_getpages(struct my_kmem_cache *cachep, my_gfp_t flags, int nodeid)
{
	#define ALLOC_WMARK_LOW		MY_WMARK_LOW
	#define ALLOC_CPUSET		0x40 /* check for correct cpuset */

	struct my_page *page;
	int i;
	flags |= cachep->gfpflags;
	if (cachep->flags & SLAB_RECLAIM_ACCOUNT)
		flags |= __GFP_RECLAIMABLE;

	my_gfp_t gfp_mask =flags | __GFP_NOTRACK;
	unsigned int order = cachep->gfporder;
	struct my_zonelist *zonelist = my_node_zonelist(0, flags | __GFP_NOTRACK);
	enum my_zone_type high_zoneidx = my_gfp_zone(gfp_mask);
	struct my_zone *preferred_zone;
	int migratetype = my_allocflags_to_migratetype(gfp_mask);

	gfp_mask &= my_gfp_allowed_mask;
	struct my_zoneref *z=zonelist->_zonerefs;
    	while (z->zone_idx > high_zoneidx)
    			z++;

    	preferred_zone = z->zone;
	gfp_mask = gfp_mask | __GFP_HARDWALL;
	page = NULL;
	struct my_zone *zone;

	z=zonelist->_zonerefs;
  	while (z->zone_idx > high_zoneidx)
    			z++;
    	zone = z->zone;
	struct my_per_cpu_pages *pcp;
	struct my_list_head *list;

	pcp = &zone_pcp(zone, 0)->pcp;
	list = &pcp->lists[migratetype];
        order = 0; 
	unsigned long count =pcp->batch;
	struct list_head *mlist =list;
	for (i = 0; i < count; ++i) {
  		int start_migratetype = migratetype;
  
  	struct my_free_area * area;
	int current_order;
	struct my_page *my_page = NULL;
	int my_migratetype, i;

	for (current_order = MAX_ORDER-1; current_order >= order; --current_order) {
	    for (i = 0; i < MIGRATE_TYPES - 1; i++) {
		my_migratetype = my_fallbacks[start_migratetype][i];
        	if (my_migratetype == MIGRATE_RESERVE)
			continue;
        	area = &(zone->free_area[current_order]);
		if (my_list_empty(&area->free_list[my_migratetype])) continue;
		my_page = list_entry(area->free_list[my_migratetype].next,struct my_page, lru);
		area->nr_free--;
		if ((current_order >= (my_pageblock_order >> 1)) ||
		start_migratetype == MIGRATE_RECLAIMABLE || my_page_group_by_mobility_disabled) {
		    struct my_page *mpage=my_page;
		    unsigned long start_pfn, end_pfn;
		    struct my_page *start_page, *end_page;

		    start_pfn = page_to_pfn(my_page);
	    	    start_pfn = start_pfn & ~(pageblock_nr_pages-1);
		    start_page = pfn_to_page(start_pfn);
		    end_page = start_page + pageblock_nr_pages - 1;
		    end_pfn = start_pfn + pageblock_nr_pages - 1;
		    int pages_moved = 0;
		    unsigned long order;
		    for (mpage = start_page; mpage <= end_page;) {
                    if (!my_test_bit(MY_PG_buddy, &mpage->flags)){
			my_page++;
			continue;
		    }
		    order = page_private(mpage);
		    my_list_del(&my_page->lru);
		    my_list_add(&my_page->lru,&zone->free_area[order].free_list[my_migratetype]);
		    mpage += 1 << order;
		    pages_moved += 1 << order;
		}
		my_migratetype = start_migratetype;
	    }
    	    my_list_del(&my_page->lru);
	    my___clear_bit(MY_PG_buddy, my_page->flags);
	    set_page_private(my_page, 0);

    	    int low = order;
	    int high = current_order;
	    unsigned long size = 1 << high;
    	    while (high > low) {
		area--;
		high--;
		size >>= 1;
		my_list_add(&my_page[size].lru, &area->free_list[my_migratetype]);
		area->nr_free++;
		set_page_private(&my_page[size], high);
		my___set_bit(MY_PG_buddy, &(&my_page[size])->flags);
	    }
			break;
	}
	break;
    }

		page =  my_page;

		my_list_add(&page->lru, mlist);
		my_list_add_tail(&page->lru, list);
		set_page_private(page, migratetype);
		mlist = &page->lru;
	}
       
		page = list_entry(list->next, struct my_page, lru);
		my_list_del(&page->lru);
	return my_page_address(page);
}

void *my2_cache_alloc_refill(struct my_kmem_cache *cachep, my_gfp_t flags)
{
	int batchcount;
	struct kmem_list3 *l3;
	struct my_array_cache *ac;
	int node;

retry:
	node = numa_node_id();
	ac =cachep->array[my_smp_processor_id()];

	batchcount = ac->batchcount;
	if (!ac->touched && batchcount > BATCHREFILL_LIMIT) {
		batchcount = BATCHREFILL_LIMIT;
	}
	l3 = cachep->nodelists[node];
	while (batchcount > 0) {
		struct list_head *entry;
		struct slab *slabp;
		entry = l3->slabs_partial.next;
		if (entry == &l3->slabs_partial) {
//			l3->free_touched = 1;
			entry = l3->slabs_free.next;
			if (entry == &l3->slabs_free)
				goto must_grow;
		}

		slabp = list_entry(entry, struct slab, list);
		while (slabp->inuse < cachep->num && batchcount--)
                {
                void *objp = slabp->s_mem + cachep->buffer_size * slabp->free;
		kmem_bufctl_t next;

		slabp->inuse++;
		next = 	((kmem_bufctl_t *) (slabp + 1)) [slabp->free];

		slabp->free = next;

		ac->entry[ac->avail++] = objp;
               }
		my_list_del(&slabp->list);
		if (slabp->free == BUFCTL_END)
			my_list_add(&slabp->list, &l3->slabs_full);
		else
			my_list_add(&slabp->list, &l3->slabs_partial);
	}

must_grow:
	l3->free_objects -= ac->avail;

	if (!ac->avail) {
	int nodeid = node; 
	void *objp=NULL;
	struct slab *slabp;
	my_size_t offset;
	my_gfp_t local_flags;
	struct kmem_list3 *l3;

	local_flags = flags & (GFP_CONSTRAINT_MASK|GFP_RECLAIM_MASK);
	l3 = cachep->nodelists[nodeid];
	offset = l3->colour_next;
	l3->colour_next++;
	if (l3->colour_next >= cachep->colour)
		l3->colour_next = 0;
	offset *= cachep->colour_off;
	objp = my2_kmem_getpages(cachep, local_flags, nodeid);

        int colour_off = offset;
	struct slab *mslabp;
	mslabp = objp + colour_off;
	colour_off += cachep->slab_size;
	mslabp->inuse = 0;
	mslabp->colouroff = colour_off;
	mslabp->s_mem = objp + colour_off;
	mslabp->nodeid = nodeid;
	mslabp->free = 0;
	slabp = mslabp;
	void *addr = objp;
	int nr_pages;
	struct my_page *page;

	page = virt_to_page(addr);

	nr_pages = 1;
//	if (likely(!PageCompound(page)))
	if (page->flags & ((1L << MY_PG_head) | (1L << MY_PG_tail)))
		nr_pages <<= cachep->gfporder;

	do {
		page->lru.prev = (struct list_head *)slabp;
		page->lru.next = (struct list_head *)cachep;
		page++;
	} while (--nr_pages);
	int i;

	for (i = 0; i < cachep->num; i++) {
		((kmem_bufctl_t *) (slabp + 1))[i] = i + 1;
	}
	((kmem_bufctl_t *) (slabp + 1))[i-1] = BUFCTL_END;
	my_list_add_tail(&slabp->list, &(l3->slabs_free));
		ac =cachep->array[my_smp_processor_id()];
		if (!ac->avail)		/* objects refilled by interrupt? */
			goto retry;
	}
	ac->touched = 1;
	return ac->entry[--ac->avail];
}

void  my2_kmem_cache_init(void)
{
	my_size_t left_over;
	struct my_cache_sizes *sizes;
	struct cache_names *names;
	int i;
	int order;
	for (i = 0; i < NUM_INIT_LISTS; i++) {
	    MY_INIT_LIST_HEAD(&(my_initkmem_list3[i]).slabs_full);
	    MY_INIT_LIST_HEAD(&(my_initkmem_list3[i]).slabs_partial);
	    MY_INIT_LIST_HEAD(&(my_initkmem_list3[i]).slabs_free);
//	    my_initkmem_list3[i].shared = NULL;
//	    my_initkmem_list3[i].alien = NULL;
	    my_initkmem_list3[i].colour_next = 0;
	    my_initkmem_list3[i].free_objects = 0;
//	    my_initkmem_list3[i].free_touched = 0;
	}
        struct my_kmem_cache *cachep = &my_cache_cache;
	cachep->nodelists[0] = &my_initkmem_list3[CACHE_CACHE + 0];
//	cachep->nodelists[0]->next_reap = jiffies + REAPTIMEOUT_LIST3 +
//	    ((unsigned long)cachep) % REAPTIMEOUT_LIST3;

	MY_INIT_LIST_HEAD(&my_cache_chain);
	my_cache_cache.array[my_smp_processor_id()] = &my_initarray_cache.cache;
	my_cache_cache.buffer_size = ALIGN(my_cache_cache.buffer_size,my_cache_line_size());
	for (order = 0; order < MAX_ORDER; order++) {
          unsigned long gfporder = order;
          my_size_t buffer_size = my_cache_cache.buffer_size;
          my_size_t align =my_cache_line_size();
          int flags=0; 
	  unsigned int *num=&my_cache_cache.num;
	  int nr_objs;
	  my_size_t mgmt_size;
	  my_size_t slab_size = PAGE_SIZE << gfporder;
	  if (flags & CFLGS_OFF_SLAB) {
		mgmt_size = 0;
		nr_objs = slab_size / buffer_size;
		if (nr_objs > SLAB_LIMIT) nr_objs = SLAB_LIMIT;
	  } else {
		nr_objs = (slab_size - sizeof(struct slab)) 
					    / (buffer_size + sizeof(kmem_bufctl_t));
		if (ALIGN(sizeof(struct slab)+nr_objs*sizeof(kmem_bufctl_t), align) + nr_objs*buffer_size > slab_size)
			nr_objs--;
		if (nr_objs > SLAB_LIMIT)
			nr_objs = SLAB_LIMIT;
		mgmt_size = ALIGN(sizeof(struct slab)+nr_objs*sizeof(kmem_bufctl_t), align);
	  }
	  *num = nr_objs;
	  left_over = slab_size - nr_objs*buffer_size - mgmt_size;
          if (my_cache_cache.num)break;
	}
	my_cache_cache.slab_size = ALIGN(my_cache_cache.num * sizeof(kmem_bufctl_t) +
				      sizeof(struct slab), my_cache_line_size());
	sizes = my_malloc_sizes;
	names = my_cache_names;
	slab_early_init = 0;
	while (sizes->cs_size != ULONG_MAX) {
	    if (!sizes->cs_cachep) {
            const char *name = names->name;
            my_size_t size = sizes->cs_size;
            my_size_t align=ARCH_KMALLOC_MINALIGN;
	    unsigned long flags=ARCH_KMALLOC_FLAGS|SLAB_PANIC; 
	    void (*ctor)(void *) = NULL;
	    my_size_t  slab_size, ralign;
	    struct my_kmem_cache *cachep = NULL;
	    my_gfp_t gfp;
    	    ralign = BYTES_PER_WORD;
    	    align = ralign;
	    gfp = GFP_NOWAIT;
	    cachep=&my_cache_cache;
	    flags =  gfp | __GFP_ZERO; 
	    void *objp;
	    flags &= my_gfp_allowed_mask;
	    struct my_array_cache *ac;
	    ac =cachep->array[my_smp_processor_id()];
	    if (ac->avail) {
		ac->touched = 1;
		objp = ac->entry[--ac->avail];
	    } else {
		int batchcount;
		struct kmem_list3 *l3;
		struct my_array_cache *ac;
		int node;
retry:
		node = numa_node_id();
		ac =cachep->array[my_smp_processor_id()];
		batchcount = ac->batchcount;
		if (!ac->touched && batchcount > BATCHREFILL_LIMIT)
			batchcount = BATCHREFILL_LIMIT;
		l3 = cachep->nodelists[node];
//		spin_lock(&l3->list_lock);
		while (batchcount > 0) {
		    struct list_head *entry;
		    struct slab *slabp;
		    entry = l3->slabs_partial.next;
		    if (entry == &l3->slabs_partial) {
//			l3->free_touched = 1;
			entry = l3->slabs_free.next;
			if (entry == &l3->slabs_free)
				goto must_grow;
			}
                    slabp = list_entry(entry, struct slab, list);
		    while (slabp->inuse < cachep->num && batchcount--) {
                        void *objp =slabp->s_mem + cachep->buffer_size * slabp->free;
			kmem_bufctl_t next;
                        slabp->inuse++;
			next = ((kmem_bufctl_t *) (slabp + 1))[slabp->free];
			slabp->free = next;
    			ac->entry[ac->avail++] = objp;
		    }
		    my_list_del(&slabp->list);
		    if (slabp->free == BUFCTL_END)
			my_list_add(&slabp->list, &l3->slabs_full);
		    else
			my_list_add(&slabp->list, &l3->slabs_partial);
		}
must_grow:
		l3->free_objects -= ac->avail;
		if (!ac->avail) {
		    int x;
		    flags =flags | GFP_THISNODE;
		    int nodeid = node; 
		    void *objp = NULL;
		    struct slab *slabp;
		    my_size_t offset;
		    my_gfp_t local_flags;
		    struct kmem_list3 *l3;
		    local_flags = flags & (GFP_CONSTRAINT_MASK|GFP_RECLAIM_MASK);
		    l3 = cachep->nodelists[nodeid];
		    offset = l3->colour_next;
		    l3->colour_next++;
		    if (l3->colour_next >= cachep->colour)
			l3->colour_next = 0;
    		    offset *= cachep->colour_off;
		    objp = my2_kmem_getpages(cachep, local_flags, nodeid);
    		    int colour_off = offset;
		    struct slab *mslabp;
		    mslabp = objp + colour_off;
		    colour_off += cachep->slab_size;
		    mslabp->inuse = 0;
		    mslabp->colouroff = colour_off;
		    mslabp->s_mem = objp + colour_off;
		    mslabp->nodeid = nodeid;
		    mslabp->free = 0;
    		    slabp = mslabp;
    	            void *addr = objp;
		    int nr_pages;
		    struct my_page *page;
    		    page = virt_to_page(addr);
		    nr_pages = 1;
		    if (page->flags & ((1L << MY_PG_head) | (1L << MY_PG_tail)))

			nr_pages <<= cachep->gfporder;

		    do {
			page->lru.prev = (struct list_head *)slabp;
			page->lru.next = (struct list_head *)cachep;
			page++;
		    } while (--nr_pages);
		    for (i = 0; i < cachep->num; i++)
			((kmem_bufctl_t *) (slabp + 1))[i] = i + 1;
    	    	    ((kmem_bufctl_t *) (slabp + 1))[i-1] = BUFCTL_END;
		    my_list_add_tail(&slabp->list, &(l3->slabs_free));
		    l3->free_objects += cachep->num;
		    x = 1;
		    ac =cachep->array[my_smp_processor_id()];
		    if (!ac->avail)		/* objects refilled by interrupt? */
			goto retry;
		    }
		    ac->touched = 1;
		    objp = ac->entry[--ac->avail];
		}
		objp = objp;
		cachep = objp;
		size = ALIGN(size, align);
		int gfporder;
		for (gfporder = 0; gfporder <= KMALLOC_MAX_ORDER; gfporder++) {
		    unsigned int num;
		    my_size_t remainder;
        	    my_size_t buffer_size = size;
        	    my_size_t *left_over = &remainder;
		    int nr_objs;
		    my_size_t mgmt_size;
		    my_size_t slab_size = PAGE_SIZE << gfporder;
		    if (flags & CFLGS_OFF_SLAB) {
			mgmt_size = 0;
			nr_objs = slab_size / buffer_size;
            	    	if (nr_objs > SLAB_LIMIT)
			    nr_objs = SLAB_LIMIT;
		    } else {
			nr_objs = (slab_size - sizeof(struct slab)) /
			(buffer_size + sizeof(kmem_bufctl_t));
			if (ALIGN(sizeof(struct slab)+nr_objs*sizeof(kmem_bufctl_t), align) + nr_objs*buffer_size > slab_size)
			    nr_objs--;
	    		if (nr_objs > SLAB_LIMIT)
			nr_objs = SLAB_LIMIT;
            		mgmt_size = ALIGN(sizeof(struct slab)+nr_objs*sizeof(kmem_bufctl_t), align);
		    }
		    num = nr_objs;
		    *left_over = slab_size - nr_objs*buffer_size - mgmt_size;
            	    if (!num)
			continue;
		    cachep->num = num;
		    cachep->gfporder = gfporder;
		    left_over = remainder;
		}
    		slab_size = ALIGN(cachep->num * sizeof(kmem_bufctl_t)
			  + sizeof(struct slab), align);
		cachep->slab_size = slab_size;
		cachep->flags = flags;
		cachep->gfpflags = 0;
		cachep->buffer_size = size;
//		cachep->ctor = ctor;
		cachep->name = name;
		if (g_cpucache_up == NONE) {
		    cachep->array[my_smp_processor_id()] = &my_initarray_generic.cache;
		    cachep->nodelists[0] = &my_initkmem_list3[SIZE_AC + 0];
//		    cachep->nodelists[0]->next_reap = jiffies + REAPTIMEOUT_LIST3 +
//			((unsigned long)cachep) % REAPTIMEOUT_LIST3;
		    g_cpucache_up = PARTIAL_AC;
		} else {
	struct my_kmem_cache *my_cachep;
	struct my_cache_sizes *csizep = my_malloc_sizes;

	while (sizeof(struct arraycache_init) > csizep->cs_size)
		csizep++;

	my_cachep = csizep->cs_cachep;

		objp = my2_cache_alloc_refill(my_cachep, gfp & my_gfp_allowed_mask);
	
        cachep->array[my_smp_processor_id()] = objp;
		if (g_cpucache_up == PARTIAL_AC) {
		    cachep->nodelists[0] = &my_initkmem_list3[SIZE_L3 + 0];
//		    cachep->nodelists[0]->next_reap = jiffies + REAPTIMEOUT_LIST3 +
//			((unsigned long)cachep) % REAPTIMEOUT_LIST3;
                    g_cpucache_up = PARTIAL_L3;
		} else {
//		    int node;
                    cachep->nodelists[0] = my2_cache_alloc_refill(my_cachep, gfp & my_gfp_allowed_mask);
		    MY_INIT_LIST_HEAD(&(cachep->nodelists[0])->slabs_full);
		    MY_INIT_LIST_HEAD(&(cachep->nodelists[0])->slabs_partial);
		    MY_INIT_LIST_HEAD(&(cachep->nodelists[0])->slabs_free);
		    cachep->nodelists[0]->shared = NULL;
		    cachep->nodelists[0]->alien = NULL;
		    cachep->nodelists[0]->colour_next = 0;
		    cachep->nodelists[0]->free_objects = 0;
		    cachep->nodelists[0]->free_touched = 0;
		}
	    }

//	    cachep->nodelists[numa_node_id()]->next_reap =
//		jiffies + REAPTIMEOUT_LIST3 +((unsigned long)cachep) % REAPTIMEOUT_LIST3;
                                             
            cachep->array[my_smp_processor_id()]->avail = 0;
	    cachep->array[my_smp_processor_id()]->limit = BOOT_CPUCACHE_ENTRIES;
	    cachep->array[my_smp_processor_id()]->batchcount = 1;
	    cachep->array[my_smp_processor_id()]->touched = 0;
	    cachep->batchcount = 1;
	    cachep->limit = BOOT_CPUCACHE_ENTRIES;

	    my_list_add(&cachep->next, &my_cache_chain);
	    sizes->cs_cachep=cachep;
	}
	sizes++;
	names++;
    }
}

#define CONSISTENT_END	(0xffe00000)
#define CONSISTENT_BASE	(CONSISTENT_END - 0x200000)

struct arm_vm_region {
    struct my_list_head	vm_list;
    unsigned long	vm_start;
    unsigned long	vm_end;
    struct my_page		*vm_pages;
    int			vm_active;
};
		    
static struct arm_vm_region consistent_head = {
	.vm_list	= LIST_HEAD_INIT(consistent_head.vm_list),
        .vm_start	= CONSISTENT_BASE,
	.vm_end		= CONSISTENT_END,
};

struct my_page *
my2__alloc_pages_nodemask(my_gfp_t gfp_mask, unsigned int order,
			struct my_zonelist *zonelist, my_nodemask_t *nodemask)
{
	enum my_zone_type high_zoneidx = my_gfp_zone(gfp_mask);
	struct my_zone *preferred_zone;
	struct my_page *page;
	int migratetype = my_allocflags_to_migratetype(gfp_mask);

	gfp_mask &= my_gfp_allowed_mask;
	struct my_zoneref *z=zonelist->_zonerefs;
    	while (z->zone_idx > high_zoneidx)
    			z++;

    	preferred_zone = z->zone;
	gfp_mask = gfp_mask | __GFP_HARDWALL;
	page = NULL;
	struct my_zone *zone;
	    z=zonelist->_zonerefs;
  	    while (z->zone_idx > high_zoneidx)
    			z++;
    	    zone = z->zone;
	struct my_per_cpu_pages *pcp;
	struct my_list_head *list;

	pcp = &zone_pcp(zone, 0)->pcp;
	list = &pcp->lists[migratetype];
        order = 0; 
	unsigned long count =pcp->batch;
	struct list_head *mlist =list;
	int i;
	
	for (i = 0; i < count; ++i) {
  	int start_migratetype = migratetype;
  
  	struct my_free_area * area;
	int current_order;
	struct my_page *my_page = NULL;
	int my_migratetype, i;

	for (current_order = MAX_ORDER-1; current_order >= order; --current_order) {
	    for (i = 0; i < MIGRATE_TYPES - 1; i++) {
		my_migratetype = my_fallbacks[start_migratetype][i];
        	if (my_migratetype == MIGRATE_RESERVE)
			continue;
        	area = &(zone->free_area[current_order]);
		if (my_list_empty(&area->free_list[my_migratetype])) continue;
		my_page = list_entry(area->free_list[my_migratetype].next,struct my_page, lru);
		area->nr_free--;
		if ((current_order >= (my_pageblock_order >> 1)) ||
		start_migratetype == MIGRATE_RECLAIMABLE || my_page_group_by_mobility_disabled) {
		    struct my_page *mpage=my_page;
		    unsigned long start_pfn, end_pfn;
		    struct my_page *start_page, *end_page;

		    start_pfn = page_to_pfn(my_page);
	    	    start_pfn = start_pfn & ~(pageblock_nr_pages-1);
		    start_page = pfn_to_page(start_pfn);
		    end_page = start_page + pageblock_nr_pages - 1;
		    end_pfn = start_pfn + pageblock_nr_pages - 1;
		    int pages_moved = 0;
		    unsigned long order;
		    for (mpage = start_page; mpage <= end_page;) {
		    if (!my_test_bit(MY_PG_buddy, &mpage->flags)){
			my_page++;
			continue;
		    }
                    order =  page_private(mpage); 
		    my_list_del(&my_page->lru);
		    my_list_add(&my_page->lru,&zone->free_area[order].free_list[my_migratetype]);
		    mpage += 1 << order;
		    pages_moved += 1 << order;
		}
		my_migratetype = start_migratetype;
	    }
    	    my_list_del(&my_page->lru);
	    my___clear_bit(MY_PG_buddy, my_page->flags);
	    set_page_private(my_page, 0);

    	    int low = order;
	    int high = current_order;
	    unsigned long size = 1 << high;
    	    while (high > low) {
		area--;
		high--;
		size >>= 1;
		my_list_add(&my_page[size].lru, &area->free_list[my_migratetype]);
		area->nr_free++;
		set_page_private(&my_page[size], high);
		my___set_bit(MY_PG_buddy, &(&my_page[size])->flags);

	    }
			break;
	}
	break;
    }

		page =  my_page;

		my_list_add(&page->lru, mlist);
		my_list_add_tail(&page->lru, list);
		set_page_private(page, migratetype);
		mlist = &page->lru;
	}
       
		page = list_entry(list->next, struct my_page, lru);
		my_list_del(&page->lru);
	return page;
}


void *
my2_dma_alloc_writecombine(struct device *dev, my_size_t size, my_dma_addr_t *handle, my_gfp_t gfp)
{
#define CONSISTENT_OFFSET(x)	(((unsigned long)(x) - CONSISTENT_BASE) >> PAGE_SHIFT)
#define CONSISTENT_PTE_INDEX(x) (((unsigned long)(x) - CONSISTENT_BASE) >> PGDIR_SHIFT)


	my_pte_t *consistent_pte[NUM_CONSISTENT_PTES];
	my_pgd_t *pgd;
	my_pmd_t *pmd;
	my_pte_t *pte;
	int i = 0;
	my_u32 base = CONSISTENT_BASE;

	do {
		pgd = pgd_offset(&my_init_mm, base);
                pmd = pmd_offset(pgd, base);
	#define PGALLOC_GFP	(GFP_KERNEL | __GFP_NOTRACK | __GFP_REPEAT | __GFP_ZERO)
	#define _PAGE_KERNEL_TABLE	(PMD_TYPE_TABLE | PMD_BIT4 | PMD_DOMAIN(DOMAIN_KERNEL))

        struct my_page *page;
        page = my2__alloc_pages_nodemask(PGALLOC_GFP, 0, my_node_zonelist(0, PGALLOC_GFP), NULL);
	my_pte_t *new = (unsigned long) my_page_address(page);
	if (new) {
		my_cpu_arm926_dcache_clean_area(new, sizeof(my_pte_t) * PTRS_PER_PTE);
		new += PTRS_PER_PTE;
	}
	    unsigned long pte_ptr = (unsigned long)new;
	    pte_ptr -= PTRS_PER_PTE * sizeof(void *);
//    	    pmd[0] = my__pmd(__pa(pte_ptr) | _PAGE_KERNEL_TABLE);
    	    pmd[0].pmd = my__pa(pte_ptr) | _PAGE_KERNEL_TABLE;
	    pmd[1].pmd = my__pa(pte_ptr) | _PAGE_KERNEL_TABLE + 256 * sizeof(my_pte_t);

//	    pmd[1] = my__pmd(__pa(pte_ptr) | _PAGE_KERNEL_TABLE + 256 * sizeof(my_pte_t));

		unsigned long ptr;

		ptr = my_pmd_val(*(pmd)) & ~(PTRS_PER_PTE * sizeof(void *) - 1);
		ptr += PTRS_PER_PTE * sizeof(void *);

		pte = my___va(ptr) + __pte_index(base);

		consistent_pte[i++] = pte;
		base += (1 << PGDIR_SHIFT);
	} while (base < CONSISTENT_END);




	struct my_page *page;

	struct arm_vm_region *c;
	unsigned long order;
	my_u64 mask = 0xffffffff;
	my_u64 limit;

	size = 0x100000;
	limit = (mask + 1) & ~mask;
	order = 8;
        page = my2__alloc_pages_nodemask(gfp, order, my_node_zonelist(0, gfp), NULL);

	struct arm_vm_region *head = &consistent_head;
	 gfp = (gfp & ~(__GFP_DMA | __GFP_HIGHMEM));
	unsigned long addr = head->vm_start;
	struct arm_vm_region *new;
        struct my_kmem_cache *my_cachep;
	struct my_cache_sizes *csizep = my_malloc_sizes;

	while (sizeof(struct arm_vm_region) > csizep->cs_size)
		csizep++;

	my_cachep = csizep->cs_cachep;
	new = my2_cache_alloc_refill(my_cachep, gfp & my_gfp_allowed_mask);
	list_for_each_entry(c, &head->vm_list, vm_list) {
		if ((addr + size) <= c->vm_start)
			goto found;
		addr = c->vm_end;
	}

 found:
	my_list_add_tail(&new->vm_list, &c->vm_list);
	new->vm_start = addr;
	new->vm_end = addr + size;
	c = new;
	int idx = CONSISTENT_PTE_INDEX(c->vm_start);
	my_u32 off = CONSISTENT_OFFSET(c->vm_start) & (PTRS_PER_PTE-1);

	pte = consistent_pte[idx] + off;
	*handle =(my_dma_addr_t)my__virt_to_bus((unsigned long)my_page_address(page));

	do {
    	    my_cpu_arm926_set_pte_ext(pte, (((unsigned long)(page-my_mem_map))<<PAGE_SHIFT) | 0x2c7, 0);              
	    page++;
	    pte++;
	    off++;
	} while (size -= PAGE_SIZE);

	return (void *)c->vm_start;


}

struct vmap_area {
	unsigned long va_start;
	unsigned long va_end;
	unsigned long flags;
	struct my_rb_node rb_node;		/* address sorted rbtree */
	struct my_list_head list;		/* address sorted list */
	struct my_list_head purge_list;	/* "lazy purge" list */
	void *private;
//	struct rcu_head rcu_head;
};

struct my_rb_root vmap_area_root = MY_RB_ROOT;

struct vm_struct *my2_get_vm_area(unsigned long size, unsigned long flags)
{
	unsigned long align=1;
	unsigned long start=VMALLOC_START;
	unsigned long end=VMALLOC_END;
	int node=-1;
	my_gfp_t gfp_mask= GFP_KERNEL;
//	 void *caller=NULL;
	static struct vmap_area *va;
	struct vm_struct *area;
	align = 1ul << PAGE_SHIFT;
	size = PAGE_ALIGN(size);
	struct my_kmem_cache *my_cachep;
	struct my_cache_sizes *csizep = my_malloc_sizes;

	while (sizeof(struct vmap_area) > csizep->cs_size)
		csizep++;
	my_cachep = csizep->cs_cachep;
        area =  my2_cache_alloc_refill(my_cachep, gfp_mask & my_gfp_allowed_mask);
	size += PAGE_SIZE;
	unsigned long vstart=start;
	unsigned long vend=end;
	struct my_rb_node *n;
	unsigned long addr;
	csizep = my_malloc_sizes;
	while (sizeof(struct vmap_area) > csizep->cs_size)
		csizep++;

	my_cachep = csizep->cs_cachep;
	
	va = my2_cache_alloc_refill(my_cachep, gfp_mask & my_gfp_allowed_mask);
	addr = ALIGN(vstart, align);
	n = vmap_area_root.rb_node;
	if (n) {
	    struct vmap_area *first = NULL;
	    do {
	        struct vmap_area *tmp;
		tmp = rb_entry(n, struct vmap_area, rb_node);
		    if (tmp->va_end >= addr) {
		        if (!first && tmp->va_start < addr + size)
			first = tmp;
			n = n->rb_left;
		    } else {
		    first = tmp;
		    n = n->rb_right;
		    }
	    } while (n);
	    if (!first)
		goto found;
	    if (first->va_end < addr) {
		n = my_rb_next(&first->rb_node);
		if (n)
		    first = rb_entry(n, struct vmap_area, rb_node);
		else
		    goto found;
	    }
	    while (addr + size > first->va_start && addr + size <= vend) {
	        addr = ALIGN(first->va_end + PAGE_SIZE, align);
		n = my_rb_next(&first->rb_node);
	        if (n)
		    first = rb_entry(n, struct vmap_area, rb_node);
			else
			goto found;
	    }
	}
found:
	va->va_start = addr;
	va->va_end = addr + size;
	va->flags = 0;
	return area;
}

void *my2__arm_ioremap(unsigned long phys_addr, my_size_t size, unsigned int mtype)
{
 	unsigned long offset = phys_addr & ~PAGE_MASK;
	const struct mem_type *type;
	unsigned long addr;
 	struct vm_struct * area;
	type = &my_mem_types[mtype];
	size = PAGE_ALIGN(offset + size);
 	area = my2_get_vm_area(size, VM_IOREMAP);

 	addr = (unsigned long)area->addr;
	my_pgd_t *pgd;
	pgd = pgd_offset_k(addr);
	my_pmd_t *pmd;
	pmd =	pmd_offset(pgd, addr);
	my_pte_t *pte;
        my_pte_t *new;
        struct my_page *page;

        #define PGALLOC_GFP	(GFP_KERNEL | __GFP_NOTRACK | __GFP_REPEAT | __GFP_ZERO)

                page = my2__alloc_pages_nodemask(PGALLOC_GFP, 0, my_node_zonelist(0, PGALLOC_GFP), NULL);

	new = (my_pte_t *) my_page_address(page);

	new += PTRS_PER_PTE;
	unsigned long pte_ptr = (unsigned long)new;
	pte_ptr -= PTRS_PER_PTE * sizeof(void *);
	
	#define _PAGE_KERNEL_TABLE	(PMD_TYPE_TABLE | PMD_BIT4 | PMD_DOMAIN(DOMAIN_KERNEL))

	unsigned long pmdval = my__pa(pte_ptr) | _PAGE_KERNEL_TABLE;
        
//        pmd[0] = __pmd(pmdval);
//	pmd[1] = __pmd(pmdval + 256 * sizeof(my_pte_t));
        pmd[0].pmd = pmdval;
	pmd[1].pmd  =pmdval + 256 * sizeof(my_pte_t);

my_pte_t *my_pmd_page_vaddr(my_pmd_t pmd)
{
return   ((void *)((unsigned long)(((pmd.pmd) & ~(PTRS_PER_PTE * sizeof(void *) - 1))+PTRS_PER_PTE * sizeof(void *)) + PAGE_OFFSET));   
}                 
		pte = my_pmd_page_vaddr(*(pmd))+(((addr) >> PAGE_SHIFT) & (PTRS_PER_PTE - 1));

	#define PROT_PTE_DEVICE	L_PTE_PRESENT | L_PTE_YOUNG | L_PTE_DIRTY | L_PTE_WRITE
        my_cpu_arm926_set_pte_ext(pte, ((phys_addr)|PROT_PTE_DEVICE | L_PTE_MT_DEV_SHARED | L_PTE_SHARED), 0);
	return (void *) (offset + addr);
}


int my2_clcdfb_probe(void)
{
        my_dma_addr_t dma;
        int cntl;
        int  mtag = 5;

//        unsigned long framesize = SZ_1M;
        unsigned long framesize = 0x100000;

    	my2_dma_alloc_writecombine(NULL, framesize,
				    &dma, GFP_KERNEL);

        unsigned long fbregs = my2__arm_ioremap(0x10120000, 0x1000, MT_DEVICE);

        int i,j;

	#define CLCD_CNTL       (0x00000018)

	#define CLCD_TIM0 0x00000000
	#define CLCD_TIM1 0x00000004
	#define CLCD_TIM2 0x00000008
	#define CLCD_TIM3 0x0000000c
	#define CLCD_UBAS 0x00000010
	#define CLCD_LBAS 0x00000014
	#define CNTL_LCDEN      (1 << 0)
	#define CNTL_LCDPWR     (1 << 11)

	writel(0x27175f9c, fbregs + CLCD_TIM0);
	writel(0x200b05df, fbregs + CLCD_TIM1);
	writel(0x67f3800, fbregs + CLCD_TIM2);
	writel(0, fbregs + CLCD_TIM3);

	writel(dma, fbregs + CLCD_UBAS);
	writel(dma, fbregs + CLCD_LBAS);

        cntl = 0x1028;
	cntl |= CNTL_LCDEN;
	writel(cntl, fbregs + CLCD_CNTL);

	cntl |= CNTL_LCDPWR;
	writel(cntl, fbregs + CLCD_CNTL);
                   for (j = 0; j < mtag; j++)
                      for (i = 0; i < 320; i++) ((unsigned long *)(0xffe00000-0x200000))[1280+j*1280+i] = 0x77777777;
                         for(;;);

return 0;
}


void  start_kernel(void)
{


struct my_machine_desc {
 int i;
};
static const struct my_machine_desc __mach_desc_VERSATILE_PB
 __attribute__((__used__))
 __attribute__((__section__(".arch.info.init")));

	/* Maintainer: ARM Ltd/Deep Blue Solutions Ltd */
//	.phys_io	= 0x101f1000,
//	.io_pg_offst	= ((0xf11f1000) >> 18) & 0xfffc,
//	.boot_params	= 0x00000100,
//	.map_io		= NULL,
//	.init_irq	= NULL,
//	.timer		= NULL,
//	.init_machine	= NULL,
//MACHINE_END

	unsigned long addr;
        my_meminfo.nr_banks = 0;
	struct membank *bank = &my_meminfo.bank[my_meminfo.nr_banks];
	bank->start = 0;
	bank->size  = 0x2000000;
	bank->node  = 0;
	my_meminfo.nr_banks++;

	my2_bootmem_init();
//	#define pmd_offset(dir, addr)	((my_pmd_t *)(dir))
        my_pmd_t *pmdp;
	for (addr = VMALLOC_END; addr; addr += PGDIR_SIZE){
		pmdp=pmd_offset(pgd_offset_k(addr), addr);
		pmdp[0].pmd = 0;
		pmdp[1].pmd = 0;
		my_clean_pmd_entry(pmdp);
		};

	my2_build_all_zonelists();
	my2_kmem_cache_init();
        my2_clcdfb_probe();

}

int initcall_debug;
int do_one_initcall(my_initcall_t fn)
{
return 0;
}
